#include "g5500_sa.h"

// insert web page as char page[]
// DO NOT EDIT THIS LINE 1
static const char page[] = ""
"<!DOCTYPE html>\n"
"\n"
"<html>\n"
"<head>\n"
"    <meta charset=\"utf-8\">\n"
"    <title>G5500</title>\n"
"\n"
"    <script>\n"
"\n"
"        const DPR = 180.0/Math.PI;              // degrees per radian\n"
"        const RPD = Math.PI/180.0;              // radians per degree\n"
"        const update_dt = 200;                  // poll period, ms\n"
"\n"
"        const cvs_w = 200;                      // canvas width (all same)\n"
"        const cvs_h = 200;                      // canvas height (all same)\n"
"        const cvs_r = 0.40*cvs_w;               // circle radius\n"
"        const dot_r = 4;                        // dot marker radius\n"
"        const font = \"10pt Verdana\";            // annotation font\n"
"\n"
"        const lbl_col = \"white\";                // label color\n"
"        const bkg_col = \"#505050\";              // background color\n"
"        const act_col = \"#A0A0A0\";              // active area color\n"
"        const grd_col = \"#C0C0C0\";              // grid color\n"
"        const cmd_col = \"#40FF40\";              // commanded color\n"
"        const now_col = \"red\";                  // current location color\n"
"\n"
"        var rot_now_az, rot_now_el;             // current rotator position\n"
"        var rot_cmd_az, rot_cmd_el;             // commanded rotator position\n"
"\n"
"        // handy\n"
"        function geid(id) {\n"
"            return document.getElementById (id);\n"
"        }\n"
"\n"
"        // send cmd to server and hand response to on function, if any\n"
"        function serverCommand (cmd, on) {\n"
"            let xhr = new XMLHttpRequest();\n"
"            xhr.onload = function() {\n"
"                if (xhr.status == 200) {\n"
"                    if (on != undefined)\n"
"                        on(xhr.response);\n"
"                } else\n"
"                    console.log (cmd + \":\" +  xhr.statusText);\n"
"            }\n"
"            xhr.open('GET', cmd);\n"
"            xhr.send();\n"
"        }\n"
"\n"
"        // draw canvas with the given id\n"
"        // TODO: draw background once, just update position\n"
"        function drawCanvas (id) {\n"
"\n"
"            // which one\n"
"            var isaz = id.charAt(0) == 'a';\n"
"            var isel = id.charAt(0) == 'e';\n"
"            var issky = id.charAt(0) == 's';\n"
"\n"
"            // get context\n"
"            var cvs = geid(id);\n"
"            var ctx = cvs.getContext('2d');\n"
"\n"
"            // draw background\n"
"            ctx.fillStyle = bkg_col;\n"
"            ctx.fillRect (0, 0, cvs_w, cvs_h);\n"
"\n"
"            // draw active area\n"
"            ctx.lineWidth = 1;\n"
"            if (isaz) {\n"
"\n"
"                // fill circle\n"
"                ctx.beginPath();\n"
"                    ctx.fillStyle = act_col;\n"
"                    ctx.arc (cvs_w/2, cvs_w/2, cvs_r, 0, 2 * Math.PI);\n"
"                ctx.closePath();\n"
"                ctx.fill();\n"
"\n"
"                // draw radial az lines\n"
"                ctx.beginPath();\n"
"                    ctx.strokeStyle = grd_col;\n"
"                    ctx.moveTo (cvs_w/2+cvs_r, cvs_h/2);\n"
"                    ctx.arc (cvs_w/2, cvs_w/2, cvs_r, 0, 2 * Math.PI);\n"
"                    for (var a = 0; a < 360; a += 30) {\n"
"                        ctx.moveTo (cvs_w/2, cvs_h/2);\n"
"                        ctx.lineTo (cvs_w/2 + cvs_r*Math.cos(RPD*a), cvs_h/2 - cvs_r*Math.sin(RPD*a)); \n"
"                    }\n"
"                ctx.stroke();\n"
"\n"
"                // draw labels\n"
"                ctx.fillStyle = lbl_col;\n"
"                ctx.textAlign = \"center\";\n"
"                ctx.fillText (\"N\", cvs_w/2, 10);\n"
"                ctx.fillText (\"E\", cvs_w-10, cvs_h/2);\n"
"                ctx.fillText (\"S\", cvs_w/2, cvs_h-10);\n"
"                ctx.fillText (\"W\", 10, cvs_h/2);\n"
"\n"
"            } else if (isel) {\n"
"\n"
"                // fill semicircle\n"
"                ctx.beginPath();\n"
"                    ctx.fillStyle = act_col;\n"
"                    ctx.arc (cvs_w/2, cvs_h/2, cvs_r, 0, Math.PI, 1);\n"
"                ctx.closePath();\n"
"                ctx.fill();\n"
"\n"
"                // draw radial el lines\n"
"                ctx.beginPath();\n"
"                    ctx.strokeStyle = grd_col;\n"
"                    ctx.moveTo (cvs_w/2+cvs_r, cvs_h/2);\n"
"                    ctx.arc (cvs_w/2, cvs_w/2, cvs_r, 0, Math.PI, 1);\n"
"                    for (var a = 0; a <= 180; a += 30) {\n"
"                        ctx.moveTo (cvs_w/2, cvs_h/2);\n"
"                        ctx.lineTo (cvs_w/2 + cvs_r*Math.cos(RPD*a), cvs_h/2 - cvs_r*Math.sin(RPD*a)); \n"
"                    }\n"
"                ctx.stroke();\n"
"\n"
"                // draw labels\n"
"                ctx.fillStyle = lbl_col;\n"
"                ctx.textAlign = \"center\";\n"
"                ctx.fillText (\"0\", cvs_w-10, cvs_h/2);\n"
"                ctx.fillText (\"180\", 10, cvs_h/2);\n"
"                ctx.fillText (\"90\", cvs_w/2, 10);\n"
"\n"
"            } else if (issky) {\n"
"\n"
"                // fill circle\n"
"                ctx.beginPath();\n"
"                    ctx.fillStyle = act_col;\n"
"                    ctx.arc (cvs_w/2, cvs_w/2, cvs_r, 0, 2 * Math.PI);\n"
"                ctx.closePath();\n"
"                ctx.fill();\n"
"\n"
"                // draw az and el lines\n"
"                ctx.beginPath();\n"
"                    ctx.strokeStyle = grd_col;\n"
"                    for (var a = 0; a < 360; a += 30) {\n"
"                        ctx.moveTo (cvs_w/2, cvs_h/2);\n"
"                        ctx.lineTo (cvs_w/2 + cvs_r*Math.cos(RPD*a), cvs_h/2 - cvs_r*Math.sin(RPD*a)); \n"
"                    }\n"
"                    for (var r = cvs_r/3; r <= cvs_r; r += cvs_r/3) {\n"
"                        ctx.moveTo (cvs_w/2+r, cvs_h/2);\n"
"                        ctx.arc (cvs_w/2, cvs_w/2, r, 0, 2 * Math.PI);\n"
"                    }\n"
"                ctx.stroke();\n"
"\n"
"                // draw labels\n"
"                ctx.fillStyle = lbl_col;\n"
"                ctx.textAlign = \"center\";\n"
"                ctx.fillText (\"N\", cvs_w/2, 10);\n"
"                ctx.fillText (\"E\", cvs_w-10, cvs_h/2);\n"
"                ctx.fillText (\"S\", cvs_w/2, cvs_h-10);\n"
"                ctx.fillText (\"W\", 10, cvs_h/2);\n"
"                ctx.fillText (\"Z\", cvs_w/2, cvs_h/2);\n"
"            }\n"
"\n"
"            // draw current and commanded rotator position\n"
"            ctx.lineWidth = 3;\n"
"            if (isaz) {\n"
"                ctx.beginPath();\n"
"                    ctx.strokeStyle = now_col;\n"
"                    ctx.moveTo (cvs_w/2, cvs_h/2);\n"
"                    ctx.lineTo (cvs_w/2 + cvs_r*Math.sin(rot_now_az), cvs_h/2 - cvs_r*Math.cos(rot_now_az));\n"
"                ctx.stroke();\n"
"                ctx.beginPath();\n"
"                    ctx.strokeStyle = cmd_col;\n"
"                    ctx.moveTo (cvs_w/2, cvs_h/2);\n"
"                    ctx.lineTo (cvs_w/2 + cvs_r*Math.sin(rot_cmd_az), cvs_h/2 - cvs_r*Math.cos(rot_cmd_az));\n"
"                ctx.stroke();\n"
"            } else if (isel) {\n"
"                ctx.beginPath();\n"
"                    ctx.strokeStyle = now_col;\n"
"                    ctx.moveTo (cvs_w/2, cvs_h/2);\n"
"                    ctx.lineTo (cvs_w/2 + cvs_r*Math.cos(rot_now_el), cvs_h/2 - cvs_r*Math.sin(rot_now_el));\n"
"                ctx.stroke();\n"
"                ctx.beginPath();\n"
"                    ctx.strokeStyle = cmd_col;\n"
"                    ctx.moveTo (cvs_w/2, cvs_h/2);\n"
"                    ctx.lineTo (cvs_w/2 + cvs_r*Math.cos(rot_cmd_el), cvs_h/2 - cvs_r*Math.sin(rot_cmd_el));\n"
"                ctx.stroke();\n"
"            } else if (issky) {\n"
"                ctx.beginPath();\n"
"                    ctx.fillStyle = now_col;\n"
"                    var z = cvs_r * (1 - 2*rot_now_el/Math.PI);\n"
"                    ctx.arc (cvs_w/2 + z*Math.sin(rot_now_az),\n"
"                                                cvs_h/2 - z*Math.cos(rot_now_az), dot_r, 0, 2*Math.PI);\n"
"                ctx.fill();\n"
"                ctx.beginPath();\n"
"                    ctx.fillStyle = cmd_col;\n"
"                    var z = cvs_r * (1 - 2*rot_cmd_el/Math.PI);\n"
"                    ctx.arc (cvs_w/2 + z*Math.sin(rot_cmd_az),\n"
"                                                cvs_h/2 - z*Math.cos(rot_cmd_az), dot_r, 0, 2*Math.PI);\n"
"                ctx.fill();\n"
"            }\n"
"        }\n"
"\n"
"        // called when user clicks Set\n"
"        function setAzEl() {\n"
"            rot_cmd_az = RPD*geid('cmd-az').value;\n"
"            rot_cmd_el = RPD*geid('cmd-el').value;\n"
"            serverCommand (\"set_pos?az=\" + DPR*rot_cmd_az + \"&el=\" + DPR*rot_cmd_el);\n"
"        }\n"
"\n"
"        // called when user types into the cmd-az input\n"
"        function setAz(e) {\n"
"            if (e.keyCode === 13) {\n"
"                rot_cmd_az = RPD*geid('cmd-az').value;\n"
"                serverCommand (\"set_pos?az=\" + DPR*rot_cmd_az + \"&el=\" + DPR*rot_now_el);\n"
"            }\n"
"        }\n"
"\n"
"        // called when user types into the cmd-el input\n"
"        function setEl(e) {\n"
"            if (e.keyCode === 13) {\n"
"                rot_cmd_el = RPD*geid('cmd-el').value;\n"
"                serverCommand (\"set_pos?az=\" + DPR*rot_now_az + \"&el=\" + DPR*rot_cmd_el);\n"
"            }\n"
"        }\n"
"\n"
"        // called when user clicks Park\n"
"        function onPark() {\n"
"            serverCommand (\"park\");\n"
"        }\n"
"\n"
"        // called when user clicks Stop\n"
"        function onStop() {\n"
"            serverCommand (\"stop\");\n"
"        }\n"
"\n"
"        // called once to initialize page\n"
"        function initPage() {\n"
"\n"
"            // set canvas sizes\n"
"            geid(\"az-canvas\").width = cvs_w;\n"
"            geid(\"az-canvas\").height = cvs_w;\n"
"            geid(\"el-canvas\").width = cvs_w;\n"
"            geid(\"el-canvas\").height = cvs_w;\n"
"            geid(\"sky-canvas\").width = cvs_w;\n"
"            geid(\"sky-canvas\").height = cvs_w;\n"
"\n"
"            geid(\"Now-label\").style = \"color:\" + now_col;\n"
"            geid(\"Set-label\").style = \"color:\" + cmd_col;\n"
"            geid(\"title-row\").style = \"background-color:\" + act_col;\n"
"\n"
"            // get and display rotator name\n"
"            serverCommand (\"get_info\", function (rsp) {\n"
"                geid('rotname').innerHTML = rsp;\n"
"            });\n"
"\n"
"            // listen to mouse clicks on az canvas to send new az\n"
"            geid(\"az-canvas\").addEventListener ('mousedown', e => {\n"
"                rot_cmd_az = (Math.atan2 (e.offsetX-cvs_w/2, cvs_h/2-e.offsetY) + 2*Math.PI) % (2*Math.PI);\n"
"                geid('cmd-az').value = (DPR*rot_cmd_az).toFixed(1);\n"
"                serverCommand (\"set_pos?az=\" + DPR*rot_cmd_az + \"&el=\" + DPR*rot_cmd_el);\n"
"            });\n"
"\n"
"            // listen to mouse clicks on el canvas to send new el\n"
"            geid(\"el-canvas\").addEventListener ('mousedown', e => {\n"
"                if (e.offsetY <= cvs_h/2) {\n"
"                    rot_cmd_el = Math.atan2 (cvs_h/2-e.offsetY, e.offsetX-cvs_w/2);\n"
"                    geid('cmd-el').value = (DPR*rot_cmd_el).toFixed(1);\n"
"                    serverCommand (\"set_pos?az=\" + DPR*rot_cmd_az + \"&el=\" + DPR*rot_cmd_el);\n"
"                }\n"
"            });\n"
"\n"
"            // listen to mouse clicks on el canvas to send new az and el\n"
"            geid(\"sky-canvas\").addEventListener ('mousedown', e => {\n"
"                var dx = e.offsetX-cvs_w/2;\n"
"                var dy = cvs_h/2-e.offsetY;\n"
"                var cmd_el = Math.PI/2 * (1 - Math.sqrt(dx*dx + dy*dy)/cvs_r);\n"
"                if (cmd_el >= 0 && cmd_el <= Math.PI/2) {\n"
"                    rot_cmd_az = (Math.atan2 (dx, dy) + 2*Math.PI) % (2*Math.PI);\n"
"                    rot_cmd_el = cmd_el;\n"
"                    geid('cmd-az').value = (DPR*rot_cmd_az).toFixed(1);\n"
"                    geid('cmd-el').value = (DPR*rot_cmd_el).toFixed(1);\n"
"                    serverCommand (\"set_pos?az=\" + DPR*rot_cmd_az + \"&el=\" + DPR*rot_cmd_el);\n"
"                }\n"
"            });\n"
"\n"
"            // poll forever to fetch and display current and commanded position\n"
"            function updatePosition() {\n"
"\n"
"                serverCommand (\"get_pos\", function(rsp) {\n"
"\n"
"                    var azel = rsp.split(/ /);\n"
"                    rot_now_az = RPD*azel[0];\n"
"                    rot_now_el = RPD*azel[1];\n"
"\n"
"                    geid('now-az').innerHTML = (DPR*rot_now_az).toFixed(1);\n"
"                    geid('now-el').innerHTML = (DPR*rot_now_el).toFixed(1);\n"
"                });\n"
"\n"
"                serverCommand (\"get_setpos\", function(rsp) {\n"
"\n"
"                    var azel = rsp.split(/ /);\n"
"                    rot_cmd_az = RPD*azel[0];\n"
"                    rot_cmd_el = RPD*azel[1];\n"
"\n"
"                    // update input field unless currently in use\n"
"                    if (document.activeElement != geid('cmd-az'))\n"
"                        geid('cmd-az').value = (DPR*rot_cmd_az).toFixed(1);\n"
"                    if (document.activeElement != geid('cmd-el'))\n"
"                        geid('cmd-el').value = (DPR*rot_cmd_el).toFixed(1);\n"
"                });\n"
"\n"
"                // show\n"
"                drawCanvas (\"az-canvas\");\n"
"                drawCanvas (\"el-canvas\");\n"
"                drawCanvas (\"sky-canvas\");\n"
"\n"
"                // repeat\n"
"                setTimeout (updatePosition, update_dt);\n"
"            }\n"
"\n"
"            // start polling\n"
"            setTimeout (updatePosition, update_dt);\n"
"        }\n"
"\n"
"    </script>\n"
"\n"
"</head>\n"
"\n"
"<body onload=\"initPage()\" >\n"
"<center>\n"
"\n"
"<h2 id='rotname'></h2>\n"
"\n"
"<table border=\"1\">\n"
"    <tr>\n"
"        <th> Azimuth </th>\n"
"        <th> Elevation </th>\n"
"        <th> Sky </th>\n"
"    </tr>\n"
"    <tr>\n"
"        <td> <canvas id='az-canvas' ></canvas> </td>\n"
"        <td> <canvas id='el-canvas' ></canvas> </td>\n"
"        <td> <canvas id='sky-canvas' ></canvas> </td>\n"
"    </tr>\n"
"</table>\n"
"\n"
"<p>\n"
"\n"
"<table border=\"1\">\n"
"\n"
"    <tr id='title-row'>\n"
"        <th width='75' ></th>\n"
"        <th width='75' id='Now-label' >Now</th>\n"
"        <th width='75' >\n"
"            <button id='Set-label' onclick=\"setAzEl()\"> Set </button>\n"
"        </th>\n"
"    </tr>\n"
"    <tr>\n"
"        <th>Az</th>\n"
"        <td id='now-az'></td>\n"
"        <td>\n"
"            <input type=\"text\" id=\"cmd-az\" minlength=\"1\" maxlength=\"6\" size=\"10\" onkeypress=\"setAz(event)\">\n"
"        </td>\n"
"    </tr>\n"
"    <tr>\n"
"        <th>El</th>\n"
"        <td id='now-el'></td>\n"
"        <td>\n"
"            <input type=\"text\" id=\"cmd-el\" minlength=\"1\" maxlength=\"6\" size=\"10\" onkeypress=\"setEl(event)\">\n"
"        </td>\n"
"    </tr>\n"
"</table>\n"
"\n"
"<p>\n"
"\n"
"<button style='color:red' onclick=\"onStop()\"> Stop </button>\n"
"&nbsp; &nbsp; &nbsp;\n"
"<button onclick=\"onPark()\"> Park </button>\n"
"\n"
"</body>\n"
"</html>\n"
;
// DO NOT EDIT THIS LINE 2




/* send the rotator control web page to web client on fp
 */
int sendWebPage (FILE *fp)
{
    fprintf (fp, "HTTP/1.0 200 OK\r\n");
    fprintf (fp, "User-Agent: g5500_sa\r\n");
    fprintf (fp, "Content-Type: text/html; charset=UTF-8\r\n");
    fprintf (fp, "Connection: close\r\n\r\n");

    fprintf (fp, "%s", page);
    return (0);
}
 
